function love.load()
	if type(love._version) == "number" then
		error("This script needs LVE 0.8.0.")
	end

	local img = love.image.newImageData("dice.png")
	dice = love.graphics.newImage(img)

	-- premultiplied preprocessing
	img:mapPixel(function(x, y, r, g, b, a)
		local pa = a/255
		return r*pa, g*pa, b*pa, a
	end)

	dice_pm = love.graphics.newImage(img)

	love.graphics.setBackgroundColor(124, 41, 255)
end

function love.draw()
	if premultiplied then
		love.graphics.print("Premultiplied", 10, 10)
		love.graphics.setBlendMode("premultiplied")
		love.graphics.draw(dice_pm)
		love.graphics.setBlendMode("alpha")
	else
		love.graphics.print("Alpha", 10, 10)
		love.graphics.draw(dice)
	end

	if not sc or screenshot then
		screenshot = false
		local img = love.graphics.newScreenshot()
		sc = love.graphics.newImage(img)
	end

	love.graphics.rectangle("fill", 590, 470, 220, 140)
	love.graphics.draw(sc, 600, 480, 0, 0.25, 0.25)
end

function love.keypressed(k)
	if k == "1" then
		premultiplied = false
		screenshot = true
	elseif k == "2" then
		premultiplied = true
		screenshot = true
	end
end
